//
// Automatically generated by the IPDL compiler.
// Edit at your own risk
//

#ifndef PPluginStream_h
#define PPluginStream_h

#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/plugins/PluginMessageUtils.h"

//-----------------------------------------------------------------------------
// Code common to PPluginStreamChild and PPluginStreamParent
//
namespace mozilla {
namespace plugins {
namespace PPluginStream {

enum State {
    StateStart = 0,
    StateError,
    StateLast
};

enum MessageType {
    PPluginStreamStart = PPluginStreamMsgStart << 10,
    PPluginStreamPreStart = (PPluginStreamMsgStart << 10) - 1,
    Msg_NPN_Write__ID,
    Reply_NPN_Write__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PPluginStreamEnd
};

class Msg_NPN_Write :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;

public:
    enum {
        ID = Msg_NPN_Write__ID
    };
    Msg_NPN_Write(const Buffer& data) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginStream::Msg_NPN_Write")
    {
        IPC::WriteParam(this, data);
    }

    static bool
    Read(
            const Message* msg,
            Buffer* data)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), data)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NPN_Write(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_NPN_Write :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;

public:
    enum {
        ID = Reply_NPN_Write__ID
    };
    Reply_NPN_Write(const int32_t& written) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginStream::Reply_NPN_Write")
    {
        IPC::WriteParam(this, written);
    }

    static bool
    Read(
            const Message* msg,
            int32_t* written)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), written)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_NPN_Write(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;

public:
    enum {
        ID = Msg___delete____ID
    };
    Msg___delete__(
            const ActorHandle& actor,
            const NPReason& reason,
            const bool& artificial) :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginStream::Msg___delete__")
    {
        IPC::WriteParam(this, actor);
        IPC::WriteParam(this, reason);
        IPC::WriteParam(this, artificial);
    }

    static bool
    Read(
            const Message* msg,
            ActorHandle* actor,
            NPReason* reason,
            bool* artificial)
    {
        void* iter = 0;

        if ((!(IPC::ReadParam(msg, (&(iter)), actor)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), reason)))) {
            return false;
        }

        if ((!(IPC::ReadParam(msg, (&(iter)), artificial)))) {
            return false;
        }

        if (iter) {
            (msg)->EndRead(iter);
        }
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply___delete__ :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;

public:
    enum {
        ID = Reply___delete____ID
    };
    Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PPluginStream::Reply___delete__")
    {
    }

    static bool
    Read(const Message* msg)
    {
        return true;
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append(")\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PPluginStream
} // namespace plugins
} // namespace mozilla

#endif // ifndef PPluginStream_h
